'''Created 16 Sept 2022 Levi'''
import platform
import ciel

# service_url = 'http://192.168.201.2:8080/NextUpServices/test/POST/'  # --> test
service_url = 'http://192.168.201.94:8080/NextUpServices/mozaikapi/POST/'  # --> production
if platform.system() == 'Linux':
    cfg_path = '/home/deeejas/git/anafapi/tests/config.ini'
elif platform.system() == 'Windows':
    cfg_path = 'C:/Users/Levi/git/anafapi/tests/config.ini'

client = ciel.CielClient(api_url=service_url)
client.confman = ciel.CielConfigManager(api_url=service_url, conf_path=cfg_path)

MEAS_UNITS = {
    'EA': 63,
    # 'HUR': 'hours',
    'KGM': 66,
    'LTR': 69,
    # 'DAY': 'days',
    'CS': 82,
    # 'C62': 'one',
    'MTR': 76,
    'PR': 89,
    'H87': 63,
    'XPP': 63,
    'TNE': 88,
    'XBE': 90}

TEMPLATES = {
    'materii prime': 29,
    'marfuri': 30,
    'produse finite': 31,
    'materiale consumabile': 32,
    'combustibili': 34,
    'ambalaje': 35,
    'semifabricate': 37,
    'cheltuieli de constituire': 38,
    'cheltuieli de dezvoltare': 39,
    'concesiuni, brevete, licente, marci comerciale, drepturi si active similare': 40,
    'fond comercial': 41,
    'alte imobilizari necorporale': 42,
    'terenuri': 43,
    'amenajari de terenuri': 44,
    'constructii': 45,
    'echipamente tehnologice (masini, utilaje si instalatii de lucru)': 46,
    'aparate si instalatii de masurare, control si reglare': 47,
    'mijloace de transport': 48,
    'animale si plantatii': 49,
    'mobilier, aparatura birotica, echipamente de protectie a valorilor umane si materiale si alte active corporale': 50,
    'obiecte de inventar': 51,
    'tichete cadou': 52,
    'marfuri custodie consumabile': 53,
    'marfuri custodie echipamente': 54,
    'marfuri-produse-finite': 56,
    'materiale cons-produse-finite': 57
}

def parse_ciel_json(invoice, codes=''):
    ciel.consts.PINV['Params']['documentStatusId'] = 2
    ciel.consts.PINV['Params']['document']['PartnerCode'] = ciel.partners.PARTNERS[invoice.seller_party.name]
    ciel.consts.PINV['Params']['document']['Date'] = invoice.issue_date.strftime('%Y-%m-%d')
    ciel.consts.PINV['Params']['document']['Series'] = ''
    ciel.consts.PINV['Params']['document']['NrDoc'] = invoice.invoice_id
    note = ''
    for line in invoice.lines:
        if line.item_description:
            note += line.item_description
        else:
            note += line.item_name
    ciel.consts.PINV['Params']['document']['Notes'] = note
    ciel.consts.PINV['Params']['document']['IsVatCollectableOnPayment'] = False
    ciel.consts.PINV['Params']['document']['DocumentLines'] = []
    for line in invoice.lines:
        params = {'ArticleCode': codes,
                  'Quantity': line.quantity,
                  'PriceIn': line.price.amount,
                  'VatInOptionId': '1',
                  'VATInQuotaValue': str(int(line.tax.percent * 100))}
        ciel.consts.PINV['Params']['document']['DocumentLines'].append(params)
    inv_payload = ciel.ujson.dumps(ciel.consts.PINV)
    return inv_payload
